﻿Ext.require('App.Const.Finances');
Ext.define('App.Control.Kivii.Finances.InvoiceApply.Execute.Form', {
    extend: 'System.Control.EntityForm',
    xtype: 'App.Control.Kivii.Finances.InvoiceApply.Execute.Form',
    entityType: 'Kivii.Finances.Entities.InvoiceApply',
    // requires: ['Package.ux'],
    layout: {
        type: 'vbox',
        pack: 'start',
        align: 'stretch'
    },
    autoScroll: true,
    id: 'execute',
    viewModel:{
    	formulas: {
            amountChineseBig: function(get) {
                let _amount = get('entity.Amount');
                return KiviiContext.Const.FinancesFunctionsMoneyToChineseBig(_amount);
            },
            isVAT: function(get) {
                let _type = get('entity.Type');
                if (_type === 'VATS') return false;
                if (_type === 'VAT') return true;
                return false;
            }
        }
    },
    dockedItems: [{
        xtype: 'toolbar',
        dock: 'top',
        items: [{
            margin: '0 0 -9 3',
            xtype: 'displayfield',
            bind: {
                value: '申请人:{owner.CreatorName},总金额:{owner.Amount}'
            },
            fieldStyle: {
                fontSize: '20px'
            }

        }, '->', {
            text: '开票',
            iconCls: 'x-fa fa-save',
            iconAlign: 'left',
            handler: '_onSaveEntity',
            bind: {
                disabled: '{!formIsValid}'
            }
        }, {
            text: '手动录入',
            iconCls: 'x-fa fa-sign-in',
            iconAlign: 'left',
            handler: '_onSaveInvoices',
            bind: {
                disabled: '{!formIsValid}'
            }
        }]
    }],
    items:[{
    	xtype: 'container',
        height: 200,
        layout: 'column',
        items: [{
            xtype: 'container',
            margin: '10 5 10 10',
            height: 180,
            columnWidth: 1 / 2,
            style: {
                border: '1px solid #C1C1C1'
            },
            layout: 'hbox',
            items: [{
                xtype: 'container',
                height: 180,
                width: 35,
                style: {
                    'border-right': '0.5px solid #C1C1C1'
                },
                html: '<div style="font-size:16px;margin-top:38px;margin-left:10px;width:10px;word-wrap:break-word;">&nbsp;&nbsp;购&nbsp;&nbsp;买&nbsp;&nbsp;方&nbsp;&nbsp;</div>'
            }, {
                xtype: 'container',
                height: 180,
                flex: 1,
                layout: 'column',
                defaults: {
                    xtype: 'textfield',
                    columnWidth: 1 / 2,
                    labelWidth: 65,
                    labelAlign: 'right',
                    margin: '0 10 10 10',
                    readOnly: true
                },
                items: [{
			        xtype: 'windowSelector',
			        columnWidth: 1,
			        margin: '10 10 5 10',
			        fieldLabel: '名&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;称',
			        editable: false,
			        readOnly: true,
			        allowBlank: false,
			        keyField: 'Kvid',
			        valueField: 'CompanyName',
			        value1Field: 'TaxNumber',
			        value2Field: 'CompanyAddress',
			        value3Field: 'Phone',
			        value4Field: 'BankName',
			        value5Field: 'BankAccount',
			        window: {
			            type: 'App.Control.Kivii.Finances.InvoiceTitle.Selector'
			        },
			        Type: 'Payee',
			        bind: {
			            key: '{entity.PayerKvid}',
			            value: '{entity.PayerName}',
			            value1: '{entity.PayerTaxNumber}',
			            value2: '{entity.PayerCompanyAddress}',
			            value3: '{entity.PayerPhone}',
			            value4: '{entity.PayerRegisteredBank}',
			            value5: '{entity.PayerBankAccount}'
			        }
			    }, {
                    fieldLabel: '纳&nbsp;&nbsp;税&nbsp;号',
                    margin: '0 10 5 10',
                    columnWidth: 1,
                    bind: '{entity.PayerTaxNumber}'
                }, {
                    fieldLabel: '地&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;址',
                    bind: '{entity.PayerCompanyAddress}'
                }, {
                    fieldLabel: '电&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;话',
                    bind: '{entity.PayerPhone}'
                }, {
                    fieldLabel: '开&nbsp;&nbsp;户&nbsp;行',
                    bind: '{entity.PayerRegisteredBank}'
                }, {
                    fieldLabel: '账&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;号',
                    bind: '{entity.PayerBankAccount}'
                }]
            }]
        }, {
            xtype: 'container',
            margin: '10 10 10 5',
            height: 180,
            columnWidth: 1 / 2,
            style: {
                border: '1px solid #C1C1C1'
            },
            layout: 'hbox',
            items: [{
                xtype: 'container',
                height: 180,
                width: 35,
                style: {
                    'border-right': '0.5px solid #C1C1C1'
                },
                html: '<div style="font-size:16px;margin-top:38px;margin-left:10px;width:10px;word-wrap:break-word;">&nbsp;&nbsp;销&nbsp;&nbsp;售&nbsp;&nbsp;方&nbsp;&nbsp;</div>'
            }, {
                xtype: 'container',
                height: 180,
                flex: 1,
                layout: 'column',
                defaults: {
                    xtype: 'textfield',
                    columnWidth: 1 / 2,
                    labelWidth: 65,
                    labelAlign: 'right',
                    margin: '0 10 10 10',
                    readOnly: true
                },
                items: [{
			        xtype: 'windowSelector',
			        columnWidth: 1,
			        margin: '10 10 5 10',
			        fieldLabel: '名&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;称',
			        editable: false,
			        readOnly: true,
			        allowBlank: false,
			        keyField: 'Kvid',
			        valueField: 'CompanyName',
			        value1Field: 'TaxNumber',
			        value2Field: 'CompanyAddress',
			        value3Field: 'Phone',
			        value4Field: 'BankName',
			        value5Field: 'BankAccount',
			        window: {
			            type: 'App.Control.Kivii.Finances.InvoiceTitle.Selector'
			        },
			        Type: 'Payee',
			        bind: {
			            key: '{entity.PayeeKvid}',
			            value: '{entity.PayeeName}',
			            value1: '{entity.PayeeTaxNumber}',
			            value2: '{entity.PayeeCompanyAddress}',
			            value3: '{entity.PayeePhone}',
			            value4: '{entity.PayeeRegisteredBank}',
			            value5: '{entity.PayeeBankAccount}'
			        }
			    }, {
                    fieldLabel: '纳&nbsp;&nbsp;税&nbsp;号',
                    margin: '0 10 5 10',
                    columnWidth: 1,
                    allowBlank: false,
                    bind: '{entity.PayeeTaxNumber}'
                }, {
                    fieldLabel: '地&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;址',
                    bind: '{entity.PayeeCompanyAddress}'
                }, {
                    fieldLabel: '电&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;话',
                    bind: '{entity.PayeePhone}'
                }, {
                    fieldLabel: '开&nbsp;&nbsp;户&nbsp;行',
                    bind: '{entity.PayeeRegisteredBank}'
                }, {
                    fieldLabel: '账&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;号',
                    bind: '{entity.PayeeBankAccount}'
                }]
            }]
        }]
    },{
        xtype: 'container',
        flex: 1,
        layout: 'fit',
        margin: '10 10 10 10',
        items: [{
            xtype: 'container',
            columnWidth: 1,
            style: {
                border: '1px solid #C1C1C1'
            },
            height: 190,
            layout: 'fit',
            items: [{
                xtype: 'entityList',
                reference:'Details',
                height: 400,
                autoScroll: true,
                // plugins: [{
                //     ptype: 'cellediting',
                //     clicksToEdit: 2
                // }],
                viewModel: {
                    data: {
                        _selection: null
                    }
                },
                bind: {
                    selection: '{_selection}'
                },
                store: {
                    pageSize: 200,
                    autoSync: false,
                    // data: [],
                    listeners: {
                        datachanged: function(_ctrl) {
                            let _view = Ext.getCmp('execute');
                            let _vm = _view.getViewModel();
                            let _totalAmountUntaxed = 0; //未税总额
                            let _totalAmountTax = 0; //总税额
                            let _totalAmount = 0; //含税总额
                            for (let _i = 0; _i < _ctrl.data.length; _i++) {
                                _totalAmountUntaxed = parseFloat((_totalAmountUntaxed + parseFloat(_ctrl.data.items[_i].data.AmountUntaxed)).toFixed(2));
                                _totalAmountTax = parseFloat((_totalAmountTax + parseFloat(_ctrl.data.items[_i].data.AmountTax)).toFixed(2));
                                _totalAmount = parseFloat((_totalAmount + parseFloat(_ctrl.data.items[_i].data.Amount)).toFixed(2));
                            }
                            _vm.set('entity.AmountUntaxed', _totalAmountUntaxed);
                            _vm.set('entity.AmountTax', _totalAmountTax);
                            _vm.set('entity.Amount', _totalAmount);
                        }
                    }
                },
                dockedItems: [{
                    xtype: 'toolbar',
                    dock: 'top',
                    items: [{
                        margin: '0 0 -9 3',
                        xtype: 'displayfield',
                        bind: {
                            value: '选中列以编辑'
                        },
                        fieldStyle: {
                            fontSize: '20px'
                        }

                    }, '->', {
                        text: '编辑',
                        iconCls: 'x-fa fa-edit',
                        iconAlign: 'left',
                        handler: '_onEditDetail',
                        bind: {
                            disabled: '{!_selection}'
                        }
                    }, {
                        text: '添加',
                        iconCls: 'x-fa fa-edit',
                        iconAlign: 'left',
                        handler: '_onAddDetail'
                    }]
                }, {
                    xtype: 'toolbar',
                    dock: 'bottom',
                    height: 45,
                    margin: '0 0 -5 0',
                    style: {
                        'border-top': '1px solid red'
                    },
                    items: ['->', {
                        xtype: 'displayfield',
                        value: '总额(不含税):'
                    }, {
                        xtype: 'displayfield',
                        bind: {
                            value: '￥{entity.AmountUntaxed}'
                        }
                    }, '-', {
                        xtype: 'displayfield',
                        value: '总税额:'
                    }, {
                        xtype: 'displayfield',
                        bind: {
                            value: '￥{entity.AmountTax}'
                        }
                    }, '-', {
                        xtype: 'displayfield',
                        value: '总额(含税):'
                    }, {
                        xtype: 'displayfield',
                        bind: {
                            value: '￥{entity.Amount} ({amountChineseBig})'
                        }
                    }]
                }],
                columns: [{
                    xtype: 'rownumberer',
                    align: 'center'
                }, {
                    text: '组别<span style="color:green;font-size:16px;margin-top:10px;">&nbsp;*</span>',
                    dataIndex: 'GoodsId',
                    width: 120
                }, {
                    text: '名称<span style="color:green;font-size:16px;margin-top:10px;">&nbsp;*</span>',
                    dataIndex: 'GoodsFullName',
                    width: 150,
                    editor: {
                        xtype: 'textfield',
                        enforceMaxLength: true,
                        maxLength: 50,
                        allowBlank: false
                    }
                }, {
                    text: '规格型号',
                    dataIndex: 'GoodsSpecifications',
                    flex: 1,
                    editor: {
                        xtype: 'textfield'
                    }
                }, {
                    text: '单位<span style="color:green;font-size:16px;margin-top:10px;">&nbsp;*</span>',
                    dataIndex: 'QuantityUnit',
                    width: 80,
                    editor: {
                        xtype: 'textfield',
                        enforceMaxLength: true,
                        maxLength: 20,
                        allowBlank: true
                    }
                }, {
                    text: '数量',
                    dataIndex: 'Quantity',
                    width: 80,
                    editor: {
                        xtype: 'numberfield',
                        hideTrigger: true,
                        // enforceMaxLength: true,
                        listeners: {
                            change: '_onChangeQuantity'
                        }
                    }
                }, {
                    text: '单价(不含税)',
                    dataIndex: 'QuantityUnitPriceUntaxed',
                    hidden: true,
                    width: 120,
                    align: 'right',
                    renderer: function(_value) {
                        let _newValue = Ext.util.Format.usMoney(_value);
                        let _newValue1 = _newValue.replace('$', '¥');
                        return _newValue1;
                    }
                }, {
                    text: '金额(不含税)',
                    hidden: true,
                    dataIndex: 'AmountUntaxed',
                    width: 180,
                    align: 'right',
                    renderer: function(_value) {
                        let _newValue = Ext.util.Format.usMoney(_value);
                        let _newValue1 = _newValue.replace('$', '¥');
                        return _newValue1;
                    }
                }, {
                    text: '单价(含税)',
                    dataIndex: 'QuantityUnitPrice',
                    width: 150,
                    align: 'right',
                    renderer: function(_value) {
                        let _newValue = Ext.util.Format.usMoney(_value);
                        let _newValue1 = _newValue.replace('$', '¥');
                        return _newValue1;
                    }
                }, {
                    text: '金额(含税)',
                    dataIndex: 'Amount',
                    width: 180,
                    align: 'right',
                    renderer: function(_value) {
                        let _newValue = Ext.util.Format.usMoney(_value);
                        let _newValue1 = _newValue.replace('$', '¥');
                        return _newValue1;
                    },
                    editor: {
                        xtype: 'numberfield',
                        hideTrigger: true,
                        enforceMaxLength: true,
                        listeners: {
                            change: '_onChangeAmount'
                        }
                    }
                }, {
                    text: '税率',
                    dataIndex: 'TaxRate',
                    align: 'right',
                    width: 100,
                    renderer: function(_value, _meta, _record) {
                        if (_value === undefined) return 0;
                        return _value * 100 + '%';
                    }
                }, {
                    text: '税额',
                    width: 120,
                    align: 'right',
                    dataIndex: 'AmountTax',
                    renderer: function(_value) {
                        let _newValue = Ext.util.Format.usMoney(_value);
                        let _newValue1 = _newValue.replace('$', '¥');
                        return _newValue1;
                    }
                }, {
                    xtype: 'actioncolumn',
                    width: 80,
                    text: '操作',
                    align: 'center',
                    menuDisabled: true,
                    sortable: false,
                    items: [{
                        iconCls: 'x-fa fa-trash-o',
                        handler: '_onDeleteDetail'
                    }]
                }],
                controller: {
                    _onChangeQuantity: function(_ctrl, _newValue, _oldValue, _eOpts) {
                        let _controller = this;
                        let _vm = _controller.getViewModel();
                        let _view = _controller.getView();
                        let _value = _newValue;
                        let _detail = _view.selection;
                        _detail.data.Quantity = _value;
                        _detail.data.QuantityUnitPrice =(parseFloat(_detail.data.Amount)/parseFloat(_detail.data.Quantity)).toFixed(2); //parseFloat(_detail.data.Amount.toFixed(2))/parseFloat(_detail.data.Quantity); //单价(含税)
                        _detail.data.QuantityUnitPriceUntaxed =(parseFloat(_detail.data.AmountUntaxed)/parseFloat(_detail.data.Quantity)).toFixed(2); //parseFloat(_detail.data.AmountUntaxed.toFixed(2))/parseFloat(_detail.data.Quantity); //单价(不含税)

                        _view.modifyEntity(_detail.data);
                        // _view.addEntity(_detail);
                    },
                    _onChangeAmount: function(_ctrl, _newValue, _oldValue, _eOpts) {
                        let _controller = this;
                        let _vm = _controller.getViewModel();
                        let _view = _controller.getView();
                        let _value = _newValue;
                        let _detail = _view.selection;
                        _detail.data.Amount = (parseFloat(_value)).toFixed(2);

                        _detail.data.AmountUntaxed =(parseFloat(_detail.data.Amount)/(1+parseFloat(_detail.data.TaxRate))).toFixed(2); //parseFloat(_detail.data.Amount.toFixed(2))/(1+parseFloat(_detail.data.TaxRate.toFixed(2))); //金额(未税)
                        _detail.data.AmountTax =(parseFloat(_detail.data.Amount)-parseFloat(_detail.data.AmountUntaxed)).toFixed(2); //parseFloat(_detail.data.AmountUntaxed.toFixed(2))*_detail.data.TaxRate; //税额
                        _detail.data.QuantityUnitPrice =(parseFloat(_detail.data.Amount)/parseFloat(_detail.data.Quantity)).toFixed(2); //parseFloat(_detail.data.Amount.toFixed(2))/parseFloat(_detail.data.Quantity); //单价(含税)
                        _detail.data.QuantityUnitPriceUntaxed =(parseFloat(_detail.data.AmountUntaxed)/parseFloat(_detail.data.Quantity)).toFixed(2); //parseFloat(_detail.data.AmountUntaxed.toFixed(2))/parseFloat(_detail.data.Quantity); //单价(不含税)

                        _view.modifyEntity(_detail.data);
                        // _view.addEntity(_detail);
                    },
                    _onEditDetail: function(_ctrl) {
                        let _controller = this;
                        let _view = _controller.getView();
                        let _vm = _controller.getViewModel();
                        if (!_view.selection) return;
                        let _data = _view.getStore().getData().items;
                        let _form = Ext.create('App.Control.Kivii.Finances.InvoiceApplyDetail.Form', {
                            header: false
                        });
                        let _win = Ext.create('Ext.window.Window', {
                            layout: 'fit',
                            title: _ctrl.text,
                            iconCls: _ctrl.iconCls,
                            // header:false,
                            iconAlign: 'left',
                            autoScroll: true,
                            width: 900,
                            height: 550,
                            modal: true,
                            resizable: false,
                            items: [_form]
                        });
                        _win.show();
                        _form.setOwner(_view.selection, _data);
                        _form.on('entityUpdated', function(_ctrl, _entities) {
                            _win.close();
                            _view.modifyEntity(_entities);
                            _view.clearSelections();
                            // _view.reload();
                        });
                    },
                    _onAddDetail: function() {
                        let _controller = this;
                        let _view = _controller.getView();
                        let _store = _view.getStore();
                        let item = {};
                        item.GoodsId = "发票1";
                        item.GoodsFullName = "产品质量委托检验";
                        item.GoodsModel = "3040601000000000000";
                        item.TaxRate = 0.06;
                        item.Quantity = 1;
                        item.Amount = 0;
                        item.QuantityUnit = '次';
                        item.AmountUntaxed = 0; //parseFloat(item.Amount.toFixed(2))/(1+parseFloat(item.TaxRate.toFixed(2))); //金额(未税)
                        item.AmountTax = 0; //parseFloat(item.AmountUntaxed.toFixed(2))*item.TaxRate; //税额
                        item.QuantityUnitPriceUntaxed = 0; //parseFloat(item.AmountUntaxed.toFixed(2))/parseFloat(item.Quantity); //单价(不含税)
                        item.QuantityUnitPrice = 0; //parseFloat(item.Amount.toFixed(2))/parseFloat(item.Quantity); //单价(含税)

                        _store.add(item);
                    },
                    _onDeleteDetail: function(_ctrl, _rowIndex, _colIndex, _item, _e, _record) {
                        let _controller = this;
                        let _vm = _controller.getViewModel();
                        let _view = _controller.getView();
                        _view.removeEntity(_record.data);
                    }
                }
            }]
        }]
    },{
        xtype: 'container',
        height: 120,
        defaults: {
            xtype: 'textfield',
            columnWidth: 1 / 4,
            labelWidth: 65,
            labelAlign: 'right',
            margin: '0 10 10 10'
        },
        layout: 'column',
        items: [{
            fieldLabel: '收&nbsp;&nbsp;款&nbsp;人',
            allowBlank: false,
            columnWidth: 1 / 3,
            bind: {
                value: '{entity.Metadata.PayeeOperatorName}'
            }
        }, {
            fieldLabel: '复&nbsp;&nbsp;核&nbsp;人',
            allowBlank: false,
            columnWidth: 1 / 3,
            bind: {
                value: '{entity.Metadata.ReviewerName}'
            }
        }, {
            fieldLabel: '开&nbsp;&nbsp;票&nbsp;人',
            allowBlank: false,
            columnWidth: 1 / 3,
            bind: {
                value: '{entity.OperatorName}'
            }
        }, {
            fieldLabel: '摘&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;要',
            columnWidth: 1,
            bind: {
                value: '{entity.Summary}'
            }
        }, {
            fieldLabel: '备&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;注',
            emptyText: '备注信息会在开具的发票备注栏体现',
            columnWidth: 1,
            bind: {
                value: '{entity.Remark}'
            }
        }]
    }],
    setOwner: function(_entity) {
        let _view = this;
        let _vm = _view.getViewModel();
        let _refs=_view.getReferences();
        
        _vm.set('entity', _entity);
        let _owner = {};
        Ext.apply(_owner, _entity);
        _vm.set('owner', _owner);
        let _store=_refs.Details.getStore();
        let item = {};
        item.GoodsId = "发票1";
        item.GoodsFullName = "产品质量委托检验";
        item.GoodsModel = "3040601000000000000";
        item.TaxRate = 0.06;
        item.Quantity = 1;
        item.Amount = parseFloat(_entity.Amount.toFixed(2));
        item.QuantityUnit = '次';
        item.AmountUntaxed = (parseFloat(item.Amount)/(1 + parseFloat(item.TaxRate))).toFixed(2); 
        item.AmountTax = (parseFloat(item.Amount)-parseFloat(item.AmountUntaxed)).toFixed(2); 
        item.QuantityUnitPrice = (parseFloat(item.Amount)/parseFloat(item.Quantity)).toFixed(2); 
        item.QuantityUnitPriceUntaxed = (parseFloat(item.AmountUntaxed)/parseFloat(item.Quantity)).toFixed(2);
        _store.add(item);
    },
    controller: {
        _onSaveInvoices: function(_ctrl) {
            let _controller = this;
            let _view = _controller.getView();
            let _vm = _controller.getViewModel();
            // let _store = _view.down('gridpanel').getStore().data;
            let _item = _vm.data.entity;
            let _issue = Ext.create('App.Control.Kivii.Finances.InvoiceApply.Invoice.Accept.Form');
            let _win = Ext.create('Ext.window.Window', {
                layout: 'fit',
                title: _ctrl.text,
                iconCls: _ctrl.iconCls,
                iconAlign: 'left',
                autoScroll: true,
                width: 580,
                height: 280,
                modal: true,
                resizable: false,
                items: [_issue]
            });
            _win.show();
            _issue.setOwner(_item,_ctrl);
            _issue.on('entityCreated', function(_ctrl, _entity) {
                _win.close();
                _view.fireEvent('entityExecuted', _controller, _entity);
            });
        },
        _onSaveEntity: function() {
            let _controller = this;
            let _view = _controller.getView();
            let _vm = _controller.getViewModel();
            let _store = _view.down('gridpanel').getStore().data;
            let _details = [];
            for (let i = 0; i < _store.items.length; i++) {
                if (_store.items[i].data.Amount <= 0) continue;
                _details.push(_store.items[i].data);
            }
            let _item=_vm.data.entity;
            if (_item.Amount !== _vm.data.owner.Amount) {
                Ext.toast("申请明细金额与申请原始金额不一致!");
                return;
            }
            Ext.Ajax.request({
                url: '/Restful/Kivii.Finances.Entities.InvoiceApply/Execute.json',
                jsonData: {
                    Item: _item,
                    Details: _details
                },
                success: function(_response) {
                    let _rtns = Ext.decode(_response.responseText);
                    Ext.toast('已进入开票列队中');
                    _view.fireEvent('entityExecuted', _controller, _rtns);
                },
                failure: function(_response) {}
            });
        }
    }
});