﻿Ext.define('App.Control.Kivii.Finances.Settlement.Biz.Report.Selector', {
    extend: 'System.Control.EntitySelector',
    // entityType:'Kivii.Customers.Entities.Customer',
    xtype: 'App.Control.Kivii.Finances.Settlement.Biz.Report.Selector',
    dataSource: '/Restful/Njzj.Connects.Entities.NjzjReport/Query.json',
    requires:['System.Control.ComboSelector'],
    filter: {},
    selModel: false,
    store: {
        autoLoad: true
    },
    tbar: [{
            xtype: 'comboSelector',
            dataSource: '/Restful/Njzj.Connects.Entities.NjzjDepartment/Query.json',
            keyField: 'DEPT',
            valueField: 'DEPTNAME',
            width:350,
            editable: false,
            listeners: {
                select: '_selectDepart'
            }
        },{
            xtype: 'datefield',
            fieldLabel: '时间范围  开始',
            format: 'Y-m-d',
            labelWidth: 90,
            reference: 'startTime',
            editable: false,
            triggers: {
                clear: {
                    weight: 2,
                    cls: 'x-fa fa-times',
                    handler: '_cleanBeginOperateTime'
                }
            },
            listeners: {
                select: '_onSelectMonth'
            }
        },
        {
            xtype: 'datefield',
            fieldLabel: '结束',
            format: 'Y-m-d',
            labelWidth: 30,
            reference: 'endTime',
            editable: false,
            triggers: {
                clear: {
                    weight: 2,
                    cls: 'x-fa fa-times',
                    handler: '_cleanEndOperateTime'
                }
            },
            listeners: {
                select: '_onSelectMonth'
            }
        }, {
            xtype: 'searchField',
            flex: 1,
            labelWidth: 60,
            queryField: '',
            emptyText: '模糊搜索报告号'
        }
    ],
    columns: {
        defaults: {
            menuDisabled: true,
            sortable: false
        },
        items: [{
            text: '序号',
            dataIndex: 'RN',
            width: 50
        }, {
            dataIndex: 'NAME',
            text: 'Name',
            width: 170
        }, {
            dataIndex: 'FOLDERNO',
            text: 'Folderno',
            width: 100
        }, {
            dataIndex: 'COMPNAME',
            text: 'Compname',
            width: 150
        }, {
            dataIndex: 'SAMPLENAME',
            text: 'Samplename',
            width: 120
        },{
            dataIndex: 'TOTALPRICE',
            text: 'TotalPrice',
            width: 100
        }, {
            dataIndex: 'LOGDATE',
            text: 'logDate',
            width: 100
        }, {
            dataIndex: 'COMPANYNAME',
            text: 'Companyname',
            width: 150
        }, {
            dataIndex: 'NAMEOFPRODUCTIONORG',
            text: 'Nameofproductionorg',
            width: 120
        }, {
            dataIndex: 'TESTTASKNOFORCCC',
            text: 'Testtasknoforcc',
            flex: 1
        }]
    },
    controller:{
    	_onSelectMonth: function(_ctrl, _time, _eOpts) {
            let _controller = this;
            let _view = _controller.getView();
            let _refs = _controller.getReferences();
            let _startTime = _refs.startTime.value;
            let _endTime = _refs.endTime.value || new Date();
            if (_startTime === null) {
                Ext.toast("请选择开始时间!");
                return;
            }
            if (_startTime > _endTime) {
                Ext.toast("开始日期不能大于结束日期!");
                return;
            }
            delete _view.filter.BeginTime;
            delete _view.filter.EndTime;
            _view.filter.BeginTime = new Date(_startTime.getFullYear(), _startTime.getMonth(), _startTime.getDate());
            _view.filter.EndTime = new Date(_endTime.getFullYear(), _endTime.getMonth(), _endTime.getDate() + 1);
            _view.reload();
        },
        _cleanBeginOperateTime: function(_ctrl) {
            _ctrl.setValue(null);
            let _me = this;
            let _view = _me.getView();
            if (_view.filter === null) _view.setFilter({});
            delete _view.filter.BeginTime;
            _view.reload();
        },
        _cleanEndOperateTime: function(_ctrl) {
            _ctrl.setValue(null);
            let _me = this;
            let _view = _me.getView();
            if (_view.filter === null) _view.setFilter({});
            delete _view.filter.EndTime;
            _view.reload();
        },
        _selectDepart: function(_ctrl, _record, _eOpts) {
            let _controller = this;
            let _view = _controller.getView();
            _view.filter.Dept=_record.data.DEPT;
            _view.reload();
        }
    }
});